class EditorPanel extends MovieClip
{
   function EditorPanel()
   {
      super();
   }
   function onLoad()
   {
      var _loc1_ = this;
      _loc1_.createEmptyMovieClip("tileContainer",1);
      _loc1_.tileContainer.attachMovie("Tile1","tile",1);
      _loc1_.tileContainer._x = 30;
      _loc1_.tileContainer._y = 30;
      _loc1_.tileType = 1;
      _loc1_.numOfTileTypes = 10;
      _loc1_.createEmptyMovieClip("spawnContainer",2);
      _loc1_.spawnContainer.attachMovie("Spawn0","spawn",1);
      _loc1_.spawnContainer._x = 90;
      _loc1_.spawnContainer._y = 30;
      _loc1_.spawnType = 50;
      _loc1_.numOfSpawnTypes = 10;
      _loc1_.createEmptyMovieClip("itemContainer",3);
      _loc1_.itemContainer.attachMovie("ItemSpawn1","item",1);
      _loc1_.itemContainer._x = 150;
      _loc1_.itemContainer._y = 30;
      _loc1_.itemType = 80;
      _loc1_.numOfItemTypes = 10;
      _loc1_.createEmptyMovieClip("gravContainer",4);
      _loc1_.gravContainer.attachMovie("GravityArrow","grav",1);
      _loc1_.gravContainer._x = 30;
      _loc1_.gravContainer._y = 80;
      _loc1_.gravType = 1;
      _loc1_.setType = 1;
   }
   function onMouseDown()
   {
      var _loc1_ = this;
      var _loc2_ = _root;
      if(_loc1_.tileContainer.hitTest(_loc2_._xmouse,_loc2_._ymouse))
      {
         if(_loc1_.setType == 1)
         {
            if(_loc1_.tileType < _loc1_.numOfTileTypes - 1)
            {
               _loc1_.tileType = _loc1_.tileType + 1;
            }
            else
            {
               _loc1_.tileType = 0;
            }
         }
         _loc1_.setType = 1;
         _loc1_.tileContainer.attachMovie("Tile" + _loc1_.tileType,"tile",1);
      }
      else if(_loc1_.spawnContainer.hitTest(_loc2_._xmouse,_loc2_._ymouse))
      {
         if(_loc1_.setType == 2)
         {
            if(_loc1_.spawnType < _loc1_.numOfSpawnTypes + 49)
            {
               _loc1_.spawnType = _loc1_.spawnType + 1;
            }
            else
            {
               _loc1_.spawnType = 50;
            }
         }
         _loc1_.setType = 2;
         _loc1_.spawnContainer.attachMovie("Spawn" + (_loc1_.spawnType - 50),"spawn",1);
      }
      else if(_loc1_.itemContainer.hitTest(_loc2_._xmouse,_loc2_._ymouse))
      {
         if(_loc1_.setType == 3)
         {
            if(_loc1_.itemType < _loc1_.numOfItemTypes + 79)
            {
               _loc1_.itemType = _loc1_.itemType + 1;
            }
            else
            {
               _loc1_.itemType = 80;
            }
         }
         _loc1_.setType = 3;
         _loc1_.itemContainer.attachMovie("ItemSpawn" + (_loc1_.itemType - 80),"item",1);
      }
      else if(_loc1_.gravContainer.hitTest(_loc2_._xmouse,_loc2_._ymouse))
      {
         if(_loc1_.setType == 4)
         {
            if(_loc1_.gravType < 8)
            {
               _loc1_.gravType = _loc1_.gravType + 1;
            }
            else
            {
               _loc1_.gravType = 0;
            }
         }
         _loc1_.setType = 4;
         if(_loc1_.gravType > 0 && _loc1_.gravType <= 4)
         {
            _loc1_.gravContainer.attachMovie("GravityArrow","grav",1);
            _loc1_.gravContainer.grav._rotation = 90 * (_loc1_.gravType - 1);
         }
         else if(_loc1_.gravType > 4)
         {
            _loc1_.gravContainer.attachMovie("GravityArrow","grav",1);
            _loc1_.gravContainer.grav._rotation = 90 * (_loc1_.gravType - 5) + 45;
         }
         else if(_loc1_.gravType == 0)
         {
            _loc1_.gravContainer.attachMovie("GravNeutral","grav",1);
         }
      }
   }
}
