class Enemy3 extends MovieClip
{
   var walkSpeed = 3;
   var xStep = 0;
   var yStep = 0;
   var onGround = false;
   var targetRot = 0;
   var walking = false;
   function Enemy3()
   {
      super();
   }
   function onLoad()
   {
      var _loc1_ = this;
      var _loc3_ = _loc1_._name.split("_");
      _loc1_.id = Number(_loc3_[1]);
      var _loc2_ = _loc1_._parent.spawnPoints[3][_loc1_.id].split(":");
      _loc1_._x = _loc2_[0] * _loc1_._parent.cellsize;
      _loc1_._y = _loc2_[1] * _loc1_._parent.cellsize;
      _loc1_._parent.cells[_loc2_[0]][_loc2_[1]].spawn = undefined;
      _loc1_.onGround = false;
      if(_loc1_._parent.cells[_loc2_[0]][_loc2_[1]].gravType > 0)
      {
         _loc1_.gravType = _loc1_._parent.cells[_loc2_[0]][_loc2_[1]].gravType;
         if(_loc1_.gravType > 4)
         {
            _loc1_.gravType -= 4;
            if(_loc1_.gravType == 0)
            {
               _loc1_.gravType = 1;
            }
         }
         _loc1_._rotation = 90 * (_loc1_.gravType - 1);
      }
      else
      {
         _loc1_.gravType = 1;
      }
      _loc1_.createEmptyMovieClip("sprite",1);
      _loc1_.sprite._y = _loc1_._parent.cellsize / 2 - 4;
      _loc1_.enemyStatus = "enemy3_walk_1";
      _loc1_.sprite.attachMovie(_loc1_.enemyStatus,"sprite",1);
      _loc1_.walking = true;
   }
   function onEnterFrame()
   {
      var _loc1_ = this;
      if(_loc1_.yStep != 0)
      {
         _loc1_.onGround = false;
      }
      _loc1_.xCell = Math.floor(_loc1_._x / _loc1_._parent.cellsize + 0.5);
      _loc1_.yCell = Math.floor(_loc1_._y / _loc1_._parent.cellsize + 0.5);
      if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].clip == undefined)
      {
         if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].tile == 2)
         {
            _loc1_.yCell = _loc1_.yCell + 1;
         }
         else if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].tile == 3)
         {
            _loc1_.xCell = _loc1_.xCell - 1;
         }
         else if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].tile == 4)
         {
            _loc1_.yCell = _loc1_.yCell - 1;
         }
         else if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].tile == 5)
         {
            _loc1_.xCell = _loc1_.xCell + 1;
         }
         _loc1_._parent.spawnPoints[3][_loc1_.id] = _loc1_.xCell + ":" + _loc1_.yCell;
         _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].spawn = 3;
         _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].spawnId = _loc1_.id;
         §§push(_loc1_.removeMovieClip());
      }
      if(_loc1_.hitTest(_loc1_._parent.player) && _loc1_.enemyStatus != "enemy3_attack_1" && _loc1_._parent.player.blinking <= 0)
      {
         _loc1_.enemyStatus = "enemy3_attack_1";
         _loc1_.sprite.attachMovie(_loc1_.enemyStatus,"sprite",1);
         _loc1_.walking = false;
         if(_loc1_._parent.player.xStep > 0)
         {
            _loc1_.sprite._xscale = 100;
            _loc1_.xStep = 0;
         }
         else if(_loc1_._parent.player.xStep < 0)
         {
            _loc1_.sprite._xscale = -100;
            _loc1_.xStep = 0;
         }
      }
      if(_loc1_.walking)
      {
         if(_loc1_.gravType == 1)
         {
            if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].tile != 4)
            {
               if(_loc1_.xStep >= 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell + 1].edges[0] == 1 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell].edges[3] == 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell + 1].edges[3] == 0)
               {
                  _loc1_.xStep = _loc1_.walkSpeed;
                  _loc1_.sprite._xscale = -100;
               }
               else if(_loc1_.xStep <= 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell + 1].edges[0] == 1 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell].edges[1] == 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell + 1].edges[1] == 0)
               {
                  _loc1_.xStep = - _loc1_.walkSpeed;
                  _loc1_.sprite._xscale = 100;
               }
               else if(_loc1_.onGround)
               {
                  _loc1_.xStep = - _loc1_.xStep;
                  _loc1_.sprite._xscale = - _loc1_.sprite._xscale;
               }
               else
               {
                  _loc1_.xStep = 0;
               }
            }
            else if(_loc1_.xStep >= 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell].edges[0] == 1 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell - 1].edges[3] == 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell].edges[3] == 0)
            {
               _loc1_.xStep = _loc1_.walkSpeed;
               _loc1_.sprite._xscale = -100;
            }
            else if(_loc1_.xStep <= 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell].edges[0] == 1 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell - 1].edges[1] == 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell].edges[1] == 0)
            {
               _loc1_.xStep = - _loc1_.walkSpeed;
               _loc1_.sprite._xscale = 100;
            }
            else if(_loc1_.onGround)
            {
               _loc1_.xStep = - _loc1_.xStep;
               _loc1_.sprite._xscale = - _loc1_.sprite._xscale;
            }
            else
            {
               _loc1_.xStep = 0;
            }
            if(_loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell].clip == undefined || _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell].clip == undefined)
            {
               _loc1_.xStep = 0;
            }
         }
         else if(_loc1_.gravType == 2)
         {
            if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].tile != 5)
            {
               if(_loc1_.xStep >= 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell + 1].edges[1] == 1 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell + 1].edges[0] == 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell + 1].edges[0] == 0)
               {
                  _loc1_.xStep = _loc1_.walkSpeed;
                  _loc1_.sprite._xscale = -100;
               }
               else if(_loc1_.xStep <= 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell - 1].edges[1] == 1 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell - 1].edges[2] == 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell - 1].edges[2] == 0)
               {
                  _loc1_.xStep = - _loc1_.walkSpeed;
                  _loc1_.sprite._xscale = 100;
               }
               else if(_loc1_.onGround)
               {
                  _loc1_.xStep = - _loc1_.xStep;
                  _loc1_.sprite._xscale = - _loc1_.sprite._xscale;
               }
               else
               {
                  _loc1_.xStep = 0;
               }
            }
            else if(_loc1_.xStep >= 0 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell + 1].edges[1] == 1 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell + 1].edges[0] == 0 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell + 1].edges[0] == 0)
            {
               _loc1_.xStep = _loc1_.walkSpeed;
               _loc1_.sprite._xscale = -100;
            }
            else if(_loc1_.xStep <= 0 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell - 1].edges[1] == 1 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell - 1].edges[2] == 0 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell - 1].edges[2] == 0)
            {
               _loc1_.xStep = - _loc1_.walkSpeed;
               _loc1_.sprite._xscale = 100;
            }
            else if(_loc1_.onGround)
            {
               _loc1_.xStep = - _loc1_.xStep;
               _loc1_.sprite._xscale = - _loc1_.sprite._xscale;
            }
            else
            {
               _loc1_.xStep = 0;
            }
            if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell + 1].clip == undefined || _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell - 1].clip == undefined)
            {
               _loc1_.xStep = 0;
            }
         }
         else if(_loc1_.gravType == 3)
         {
            if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].tile != 2)
            {
               if(_loc1_.xStep >= 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell - 1].edges[2] == 1 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell].edges[1] == 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell - 1].edges[1] == 0)
               {
                  _loc1_.xStep = _loc1_.walkSpeed;
                  _loc1_.sprite._xscale = -100;
               }
               else if(_loc1_.xStep <= 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell - 1].edges[2] == 1 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell].edges[3] == 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell - 1].edges[3] == 0)
               {
                  _loc1_.xStep = - _loc1_.walkSpeed;
                  _loc1_.sprite._xscale = 100;
               }
               else if(_loc1_.onGround)
               {
                  _loc1_.xStep = - _loc1_.xStep;
                  _loc1_.sprite._xscale = - _loc1_.sprite._xscale;
               }
               else
               {
                  _loc1_.xStep = 0;
               }
            }
            else if(_loc1_.xStep >= 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell].edges[2] == 1 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell + 1].edges[1] == 0 && _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell].edges[1] == 0)
            {
               _loc1_.xStep = _loc1_.walkSpeed;
               _loc1_.sprite._xscale = -100;
            }
            else if(_loc1_.xStep <= 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell].edges[2] == 1 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell + 1].edges[3] == 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell].edges[3] == 0)
            {
               _loc1_.xStep = - _loc1_.walkSpeed;
               _loc1_.sprite._xscale = 100;
            }
            else if(_loc1_.onGround)
            {
               _loc1_.xStep = - _loc1_.xStep;
               _loc1_.sprite._xscale = - _loc1_.sprite._xscale;
            }
            else
            {
               _loc1_.xStep = 0;
            }
            if(_loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell].clip == undefined || _loc1_._parent.cells[_loc1_.xCell - 1][_loc1_.yCell].clip == undefined)
            {
               _loc1_.xStep = 0;
            }
         }
         else if(_loc1_.gravType == 4)
         {
            if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].tile != 3)
            {
               if(_loc1_.xStep >= 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell - 1].edges[3] == 1 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell - 1].edges[2] == 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell - 1].edges[2] == 0)
               {
                  _loc1_.xStep = _loc1_.walkSpeed;
                  _loc1_.sprite._xscale = -100;
               }
               else if(_loc1_.xStep <= 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell + 1].edges[3] == 1 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell + 1].edges[0] == 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell + 1].edges[0] == 0)
               {
                  _loc1_.xStep = - _loc1_.walkSpeed;
                  _loc1_.sprite._xscale = 100;
               }
               else if(_loc1_.onGround)
               {
                  _loc1_.xStep = - _loc1_.xStep;
                  _loc1_.sprite._xscale = - _loc1_.sprite._xscale;
               }
               else
               {
                  _loc1_.xStep = 0;
               }
            }
            else if(_loc1_.xStep >= 0 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell - 1].edges[3] == 1 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell - 1].edges[2] == 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell - 1].edges[2] == 0)
            {
               _loc1_.xStep = _loc1_.walkSpeed;
               _loc1_.sprite._xscale = -100;
            }
            else if(_loc1_.xStep <= 0 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell + 1].edges[3] == 1 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell + 1].edges[0] == 0 && _loc1_._parent.cells[_loc1_.xCell + 1][_loc1_.yCell + 1].edges[0] == 0)
            {
               _loc1_.xStep = - _loc1_.walkSpeed;
               _loc1_.sprite._xscale = 100;
            }
            else if(_loc1_.onGround)
            {
               _loc1_.xStep = - _loc1_.xStep;
               _loc1_.sprite._xscale = - _loc1_.sprite._xscale;
            }
            else
            {
               _loc1_.xStep = 0;
            }
            if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell + 1].clip == undefined || _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell - 1].clip == undefined)
            {
               _loc1_.xStep = 0;
            }
         }
      }
      if(_loc1_._parent.gravity < _loc1_._parent.maxspeed)
      {
         _loc1_.yStep += _loc1_._parent.gravity;
      }
      if(_loc1_.gravType == 1)
      {
         _loc1_.futureY = _loc1_._y + _loc1_.yStep;
         _loc1_.futureX = _loc1_._x + _loc1_.xStep;
         _loc1_.targetRot = 0;
      }
      else if(_loc1_.gravType == 2)
      {
         _loc1_.futureY = _loc1_._y + _loc1_.xStep;
         _loc1_.futureX = _loc1_._x - _loc1_.yStep;
         _loc1_.targetRot = 90;
      }
      else if(_loc1_.gravType == 3)
      {
         _loc1_.futureY = _loc1_._y - _loc1_.yStep;
         _loc1_.futureX = _loc1_._x - _loc1_.xStep;
         if(_loc1_._rotation <= -90)
         {
            _loc1_.targetRot = -180;
         }
         else
         {
            _loc1_.targetRot = 180;
         }
      }
      else if(_loc1_.gravType == 4)
      {
         _loc1_.futureY = _loc1_._y - _loc1_.xStep;
         _loc1_.futureX = _loc1_._x + _loc1_.yStep;
         if(_loc1_._rotation >= 180)
         {
            _loc1_.targetRot = 270;
         }
         else
         {
            _loc1_.targetRot = -90;
         }
      }
      if((_loc1_.targetRot - _loc1_._rotation) * (_loc1_.targetRot - _loc1_._rotation) > 5)
      {
         _loc1_._rotation += (_loc1_.targetRot - _loc1_._rotation) / 2;
      }
      else
      {
         _loc1_._rotation = _loc1_.targetRot;
         if(_loc1_._rotation == -180)
         {
            _loc1_._rotation = 180;
         }
         if(_loc1_._rotation == 270)
         {
            _loc1_._rotation = -90;
         }
      }
      _loc1_.xCell = Math.floor(_loc1_.futureX / _loc1_._parent.cellsize + 0.5);
      _loc1_.yCell = Math.floor(_loc1_.futureY / _loc1_._parent.cellsize + 0.5);
      if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].gravType != 0 && _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].gravType != undefined)
      {
         if(_loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].gravType <= 4)
         {
            _loc1_.gravType = _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].gravType;
            _loc1_.shiftGrav = 0;
         }
         else if(_loc1_.shiftGrav != _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].gravType - 4)
         {
            _loc1_.shiftGrav = _loc1_._parent.cells[_loc1_.xCell][_loc1_.yCell].gravType - 4;
            if(_loc1_.shiftGrav == _loc1_.gravType)
            {
               if(_loc1_.gravType < 4)
               {
                  _loc1_.gravType = _loc1_.gravType + 1;
               }
               else
               {
                  _loc1_.gravType = 1;
               }
            }
            else if(_loc1_.gravType > 1)
            {
               _loc1_.gravType = _loc1_.gravType - 1;
            }
            else
            {
               _loc1_.gravType = 4;
            }
         }
      }
      _loc1_.rawHitTest();
      _loc1_._y = _loc1_.futureY;
      _loc1_._x = _loc1_.futureX;
   }
   function rawHitTest()
   {
      var _loc1_ = this;
      var _loc3_ = -1;
      while(_loc3_ <= 1)
      {
         var _loc2_ = -1;
         while(_loc2_ <= 1)
         {
            if(_loc1_.xCell != 0 && _loc1_.yCell != 0)
            {
               _loc1_.detailHitTest(_loc1_.xCell + _loc3_,_loc1_.yCell + _loc2_);
            }
            else if(_loc1_.xCell == 0 && _loc1_.yCell != 0 && _loc3_ >= 0)
            {
               _loc1_.detailHitTest(_loc1_.xCell + _loc3_,_loc1_.yCell + _loc2_);
            }
            else if(_loc1_.xCell != 0 && _loc1_.yCell == 0 && _loc2_ >= 0)
            {
               _loc1_.detailHitTest(_loc1_.xCell + _loc3_,_loc1_.yCell + _loc2_);
            }
            else if(_loc3_ >= 0 && _loc2_ >= 0)
            {
               _loc1_.detailHitTest(_loc1_.xCell + _loc3_,_loc1_.yCell + _loc2_);
            }
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
   }
   function detailHitTest(tmpX, tmpY)
   {
      var _loc1_ = this;
      var _loc2_ = tmpX;
      var _loc3_ = tmpY;
      _loc2_;
      _loc3_;
      var tile = _loc1_._parent.cells[_loc2_][_loc3_].tile;
      if(tile >= 1 && tile <= 5)
      {
         var left = _loc1_.futureX - _loc1_._width / 2;
         var right = _loc1_.futureX + _loc1_._width / 2;
         var top = _loc1_.futureY - _loc1_._height / 2;
         var bottom = _loc1_.futureY + _loc1_._height / 2;
         if(tile == 1)
         {
            var cLeft = _loc1_._parent.cells[_loc2_][_loc3_].clip._x - _loc1_._parent.cellsize / 2;
            var cRight = _loc1_._parent.cells[_loc2_][_loc3_].clip._x + _loc1_._parent.cellsize / 2;
            var cTop = _loc1_._parent.cells[_loc2_][_loc3_].clip._y - _loc1_._parent.cellsize / 2;
            var cBottom = _loc1_._parent.cells[_loc2_][_loc3_].clip._y + _loc1_._parent.cellsize / 2;
         }
         else if(tile == 2)
         {
            var cLeft = _loc1_._parent.cells[_loc2_][_loc3_].clip._x - _loc1_._parent.cellsize / 2;
            var cRight = _loc1_._parent.cells[_loc2_][_loc3_].clip._x + _loc1_._parent.cellsize / 2;
            var cTop = _loc1_._parent.cells[_loc2_][_loc3_].clip._y - _loc1_._parent.cellsize / 2;
            var cBottom = _loc1_._parent.cells[_loc2_][_loc3_].clip._y;
         }
         else if(tile == 3)
         {
            var cLeft = _loc1_._parent.cells[_loc2_][_loc3_].clip._x;
            var cRight = _loc1_._parent.cells[_loc2_][_loc3_].clip._x + _loc1_._parent.cellsize / 2;
            var cTop = _loc1_._parent.cells[_loc2_][_loc3_].clip._y - _loc1_._parent.cellsize / 2;
            var cBottom = _loc1_._parent.cells[_loc2_][_loc3_].clip._y + _loc1_._parent.cellsize / 2;
         }
         else if(tile == 4)
         {
            var cLeft = _loc1_._parent.cells[_loc2_][_loc3_].clip._x - _loc1_._parent.cellsize / 2;
            var cRight = _loc1_._parent.cells[_loc2_][_loc3_].clip._x + _loc1_._parent.cellsize / 2;
            var cTop = _loc1_._parent.cells[_loc2_][_loc3_].clip._y;
            var cBottom = _loc1_._parent.cells[_loc2_][_loc3_].clip._y + _loc1_._parent.cellsize / 2;
         }
         else if(tile == 5)
         {
            var cLeft = _loc1_._parent.cells[_loc2_][_loc3_].clip._x - _loc1_._parent.cellsize / 2;
            var cRight = _loc1_._parent.cells[_loc2_][_loc3_].clip._x;
            var cTop = _loc1_._parent.cells[_loc2_][_loc3_].clip._y - _loc1_._parent.cellsize / 2;
            var cBottom = _loc1_._parent.cells[_loc2_][_loc3_].clip._y + _loc1_._parent.cellsize / 2;
         }
         if(bottom > cTop && top < cBottom && left < cRight && right > cLeft)
         {
            var projUp = cTop - _loc1_._height / 2 - _loc1_.futureY;
            var projDown = cBottom + _loc1_._height / 2 - _loc1_.futureY;
            var projLeft = cLeft - _loc1_._width / 2 - _loc1_.futureX;
            var projRight = cRight + _loc1_._width / 2 - _loc1_.futureX;
            if(Math.sqrt(projUp * projUp) < Math.sqrt(projDown * projDown))
            {
               var projY = projUp;
            }
            else
            {
               var projY = projDown;
            }
            if(Math.sqrt(projLeft * projLeft) < Math.sqrt(projRight * projRight))
            {
               var projX = projLeft;
            }
            else
            {
               var projX = projRight;
            }
            if(Math.sqrt(projX * projX) < Math.sqrt(projY * projY))
            {
               if(!(_loc1_.gravType == 1 || _loc1_.gravType == 3))
               {
                  if(_loc1_.gravType == 2 || _loc1_.gravType == 4)
                  {
                     _loc1_.yStep = 0;
                  }
               }
               _loc1_.futureX += projX;
               if(projX == projRight && _loc1_.gravType == 2)
               {
                  if(!_loc1_.onGround)
                  {
                     _loc1_.onGround = true;
                  }
               }
               else if(projX == projLeft && _loc1_.gravType == 4)
               {
                  if(!_loc1_.onGround)
                  {
                     _loc1_.onGround = true;
                  }
               }
            }
            else
            {
               if(_loc1_.gravType == 1 || _loc1_.gravType == 3)
               {
                  _loc1_.yStep = 0;
               }
               else if(_loc1_.gravType == 2 || _loc1_.gravType == 4)
               {
               }
               _loc1_.futureY += projY;
               if(projY == projUp && _loc1_.gravType == 1)
               {
                  if(!_loc1_.onGround)
                  {
                     _loc1_.onGround = true;
                  }
               }
               else if(projY == projDown && _loc1_.gravType == 3)
               {
                  if(!_loc1_.onGround)
                  {
                     _loc1_.onGround = true;
                  }
               }
            }
         }
      }
   }
}
