class TraceWorld extends MovieClip
{
   var tilesVisible = true;
   function TraceWorld()
   {
      super();
   }
   function onLoad()
   {
      var _loc1_ = this;
      _loc1_.gravity = 1;
      _loc1_.maxspeed = 20;
      _loc1_.xsize = 60;
      _loc1_.ysize = 60;
      _loc1_.cellsize = 50;
      _loc1_.camFollow = true;
      _loc1_.numEnemyTypes = 5;
      _loc1_.numItemTypes = 3;
      _loc1_.cells = new Array();
      _loc1_.i = 0;
      while(_loc1_.i < _loc1_.xsize)
      {
         _loc1_.cells[_loc1_.i] = new Array();
         _loc1_.j = 0;
         while(_loc1_.j < _loc1_.ysize)
         {
            _loc1_.cells[_loc1_.i][_loc1_.j] = new Object();
            _loc1_.cells[_loc1_.i][_loc1_.j].tile = 0;
            _loc1_.cells[_loc1_.i][_loc1_.j].edges = new Array();
            _loc1_.j = _loc1_.j + 1;
         }
         _loc1_.i = _loc1_.i + 1;
      }
   }
   function buildLevel(mapString)
   {
      var _loc1_ = this;
      var _loc2_ = mapString;
      _loc2_ = Map.decode(_loc2_);
      _loc1_.mapArray = new Array();
      _loc1_.mapArray = _loc2_.split(":");
      _loc1_.mapArray2 = _loc1_.mapArray[0].split("|");
      _loc1_.spawnPoints = new Array();
      _loc1_.itemPoints = new Array();
      _loc1_.i = 0;
      while(_loc1_.i < 30)
      {
         _loc1_.spawnPoints[_loc1_.i] = new Array();
         _loc1_.i = _loc1_.i + 1;
      }
      _loc1_.i = 0;
      while(_loc1_.i < 20)
      {
         _loc1_.itemPoints[_loc1_.i] = new Array();
         _loc1_.i = _loc1_.i + 1;
      }
      _loc1_.xsize = Number(_loc1_.mapArray2[0]);
      _loc1_.ysize = Number(_loc1_.mapArray2[1]);
      _loc1_.depth = 1000;
      _loc1_.j = 0;
      while(_loc1_.j < _loc1_.ysize)
      {
         _loc1_.i = 0;
         while(_loc1_.i < _loc1_.xsize)
         {
            _loc1_.currPos = (_loc1_.i + _loc1_.j * _loc1_.xsize) * 3;
            _loc1_.gravType = Number(_loc1_.mapArray[1].substr(_loc1_.currPos,1));
            _loc1_.tileType = Number(_loc1_.mapArray[1].substr(_loc1_.currPos + 1,2));
            if(_loc1_.tileType >= 50 && _loc1_.tileType < 80)
            {
               _loc1_.tileType = 0;
            }
            else if(_loc1_.tileType >= 80)
            {
               _loc1_.tileType = 0;
            }
            _loc1_.cells[_loc1_.i][_loc1_.j].tile = _loc1_.tileType;
            _loc1_.cells[_loc1_.i][_loc1_.j].clip = new MovieClip();
            _loc1_.attachMovie("TraceCell","cell_" + _loc1_.i + "_" + _loc1_.j,_loc1_.depth);
            _loc1_.depth = _loc1_.depth + 1;
            _loc1_.i = _loc1_.i + 1;
         }
         _loc1_.j = _loc1_.j + 1;
      }
   }
}
