class World extends MovieClip
{
   var gravity = 1;
   var maxspeed = 20;
   var xsize = 60;
   var ysize = 60;
   var cellsize = 50;
   var numEnemyTypes = 9;
   var numItemTypes = 4;
   var camFollow = true;
   var tilesVisible = true;
   var reSpawnCounter = 0;
   var triggerStatus = 0;
   var triggerMemory = 0;
   var combatStatus = 100;
   var worldTimer = 0;
   var triggers = new Array();
   var triggerPile = new Array();
   function World()
   {
      super();
   }
   function onLoad()
   {
   }
   function hideTiles()
   {
      this.tilesVisible = false;
   }
   function buildLevel(mapString)
   {
      var _loc1_ = this;
      _root.itemsTotal[_root.currLvl - 1] = 0;
      var mapString = Map.decode(mapString);
      var mapArray = mapString.split(":");
      var mapArray2 = mapArray[0].split("|");
      _loc1_.spawnPoints = new Array();
      _loc1_.itemPoints = new Array();
      var _loc2_ = 0;
      while(_loc2_ < 30)
      {
         _loc1_.spawnPoints[_loc2_] = new Array();
         _loc2_ = _loc2_ + 1;
      }
      _loc2_ = 0;
      while(_loc2_ < 20)
      {
         _loc1_.itemPoints[_loc2_] = new Array();
         _loc2_ = _loc2_ + 1;
      }
      _loc1_.xsize = Number(mapArray2[0]);
      _loc1_.ysize = Number(mapArray2[1]);
      _loc1_.cells = new Array();
      _loc2_ = 0;
      while(_loc2_ < _loc1_.xsize)
      {
         _loc1_.cells[_loc2_] = new Array();
         var _loc3_ = 0;
         while(_loc3_ < _loc1_.ysize)
         {
            _loc1_.cells[_loc2_][_loc3_] = new Object();
            _loc1_.cells[_loc2_][_loc3_].tile = 0;
            _loc1_.cells[_loc2_][_loc3_].edges = new Array();
            _loc3_ = _loc3_ + 1;
         }
         _loc2_ = _loc2_ + 1;
      }
      var depth = 100;
      var currPos = 0;
      var gravType = 0;
      var tileType = 0;
      _loc3_ = 0;
      while(_loc3_ < _loc1_.ysize)
      {
         _loc2_ = 0;
         while(_loc2_ < _loc1_.xsize)
         {
            currPos = (_loc2_ + _loc3_ * _loc1_.xsize) * 3;
            gravType = Number(mapArray[1].substr(currPos,1));
            tileType = Number(mapArray[1].substr(currPos + 1,2));
            if(tileType >= 50 && tileType < 80)
            {
               if(tileType == 50)
               {
                  _loc1_.spawnPoints[0][0] = _loc2_ + ":" + _loc3_;
               }
               else
               {
                  _loc1_.spawnPoints[tileType - 50][_loc1_.spawnPoints[tileType - 50].length] = _loc2_ + ":" + _loc3_;
               }
               _loc1_.cells[_loc2_][_loc3_].spawn = tileType - 50;
               _loc1_.cells[_loc2_][_loc3_].spawnId = _loc1_.spawnPoints[tileType - 50].length - 1;
               _loc1_.cells[_loc2_][_loc3_].spawnAlive = true;
               tileType = 0;
            }
            else if(tileType >= 80)
            {
               _loc1_.itemPoints[tileType - 80][_loc1_.itemPoints[tileType - 80].length] = _loc2_ + ":" + _loc3_;
               _loc1_.cells[_loc2_][_loc3_].item = tileType - 80;
               _loc1_.cells[_loc2_][_loc3_].itemId = _loc1_.itemPoints[tileType - 80].length - 1;
               _loc1_.cells[_loc2_][_loc3_].itemAlive = true;
               if(tileType - 80 > 0 && tileType - 80 <= 3)
               {
                  _root.itemsTotal[_root.currLvl - 1]++;
               }
               tileType = 0;
            }
            if(tileType == 6)
            {
               _loc1_.cells[_loc2_][_loc3_].kill = true;
               tileType = 0;
            }
            if(tileType == 7)
            {
               _loc1_.cells[_loc2_][_loc3_].checkpoint = true;
               tileType = 0;
            }
            if(tileType == 8)
            {
               _loc1_.cells[_loc2_][_loc3_].exit = true;
               tileType = 0;
            }
            if(tileType == 9)
            {
               _loc1_.cells[_loc2_][_loc3_].triggerpoint = true;
               tileType = 0;
            }
            _loc1_.cells[_loc2_][_loc3_].depth = depth;
            _loc1_.cells[_loc2_][_loc3_].tile = tileType;
            _loc1_.cells[_loc2_][_loc3_].gravType = gravType;
            _loc1_.cells[_loc2_][_loc3_].clip = undefined;
            depth++;
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
      _loc3_ = 0;
      while(_loc3_ < _loc1_.ysize)
      {
         _loc2_ = 0;
         while(_loc2_ < _loc1_.xsize)
         {
            if(_loc1_.cells[_loc2_][_loc3_].tile == 0)
            {
               _loc1_.cells[_loc2_][_loc3_].edges[0] = 0;
               _loc1_.cells[_loc2_][_loc3_].edges[1] = 0;
               _loc1_.cells[_loc2_][_loc3_].edges[2] = 0;
               _loc1_.cells[_loc2_][_loc3_].edges[3] = 0;
            }
            else if(_loc1_.cells[_loc2_][_loc3_].tile == 1)
            {
               if(_loc1_.cells[_loc2_][_loc3_ - 1].tile == 0 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 3 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 5 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 2)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[0] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[0] = 0;
               }
               if(_loc1_.cells[_loc2_ + 1][_loc3_].tile == 0 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 2 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 3 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 4)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[1] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[1] = 0;
               }
               if(_loc1_.cells[_loc2_][_loc3_ + 1].tile == 0 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 3 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 4 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 5)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[2] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[2] = 0;
               }
               if(_loc1_.cells[_loc2_ - 1][_loc3_].tile == 0 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 2 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 4 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 5)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[3] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[3] = 0;
               }
            }
            else if(_loc1_.cells[_loc2_][_loc3_].tile == 2)
            {
               if(_loc1_.cells[_loc2_][_loc3_ - 1].tile == 0 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 2 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 3 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 5)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[0] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[0] = 0;
               }
               if(_loc1_.cells[_loc2_ + 1][_loc3_].tile == 0 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 3 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 4)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[1] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[1] = 0;
               }
               if(_loc1_.cells[_loc2_][_loc3_ + 1].tile == 0 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 2 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 3 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 4 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 5)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[2] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[2] = 0;
               }
               if(_loc1_.cells[_loc2_ - 1][_loc3_].tile == 0 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 5 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 4)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[3] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[3] = 0;
               }
            }
            else if(_loc1_.cells[_loc2_][_loc3_].tile == 3)
            {
               if(_loc1_.cells[_loc2_][_loc3_ - 1].tile == 0 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 2 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 5)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[0] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[0] = 0;
               }
               if(_loc1_.cells[_loc2_ + 1][_loc3_].tile == 0 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 2 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 3 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 4)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[1] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[1] = 0;
               }
               if(_loc1_.cells[_loc2_][_loc3_ + 1].tile == 0 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 5 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 4)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[2] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[2] = 0;
               }
               if(_loc1_.cells[_loc2_ - 1][_loc3_].tile == 0 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 2 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 3 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 4 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 5)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[3] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[3] = 0;
               }
            }
            else if(_loc1_.cells[_loc2_][_loc3_].tile == 4)
            {
               if(_loc1_.cells[_loc2_][_loc3_ - 1].tile == 0 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 2 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 3 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 4 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 5)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[0] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[0] = 0;
               }
               if(_loc1_.cells[_loc2_ + 1][_loc3_].tile == 0 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 3 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 2)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[1] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[1] = 0;
               }
               if(_loc1_.cells[_loc2_][_loc3_ + 1].tile == 0 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 3 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 4 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 5)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[2] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[2] = 0;
               }
               if(_loc1_.cells[_loc2_ - 1][_loc3_].tile == 0 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 5 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 2)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[3] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[3] = 0;
               }
            }
            else if(_loc1_.cells[_loc2_][_loc3_].tile == 5)
            {
               if(_loc1_.cells[_loc2_][_loc3_ - 1].tile == 0 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 2 || _loc1_.cells[_loc2_][_loc3_ - 1].tile == 3)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[0] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[0] = 0;
               }
               if(_loc1_.cells[_loc2_ + 1][_loc3_].tile == 0 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 2 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 3 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 4 || _loc1_.cells[_loc2_ + 1][_loc3_].tile == 5)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[1] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[1] = 0;
               }
               if(_loc1_.cells[_loc2_][_loc3_ + 1].tile == 0 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 3 || _loc1_.cells[_loc2_][_loc3_ + 1].tile == 4)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[2] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[2] = 0;
               }
               if(_loc1_.cells[_loc2_ - 1][_loc3_].tile == 0 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 2 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 4 || _loc1_.cells[_loc2_ - 1][_loc3_].tile == 5)
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[3] = 1;
               }
               else
               {
                  _loc1_.cells[_loc2_][_loc3_].edges[3] = 0;
               }
            }
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
      var tmpArr = _loc1_.spawnPoints[0][0].split(":");
      _loc1_._x = Math.round((- tmpArr[0]) * _loc1_.cellsize * 10) / 10;
      _loc1_._y = Math.round((- tmpArr[1]) * _loc1_.cellsize * 10) / 10;
   }
   function startGame()
   {
      var _loc1_ = this;
      if(_root.currLvl == 4)
      {
         _root.itemsTotalLvl[0] = Number(_root.itemsTotal[0]) + Number(_root.itemsTotal[1]) + Number(_root.itemsTotal[2]) + Number(_root.itemsTotal[3]);
      }
      else if(_root.currLvl == 8)
      {
         _root.itemsTotalLvl[1] = Number(_root.itemsTotal[4]) + Number(_root.itemsTotal[5]) + Number(_root.itemsTotal[6]) + Number(_root.itemsTotal[7]);
      }
      else if(_root.currLvl == 12)
      {
         _root.itemsTotalLvl[2] = Number(_root.itemsTotal[8]) + Number(_root.itemsTotal[9]) + Number(_root.itemsTotal[10]) + Number(_root.itemsTotal[11]);
      }
      var tmpArr = _loc1_.spawnPoints[0][0].split(":");
      _loc1_.currX = Number(tmpArr[0]);
      _loc1_.currY = Number(tmpArr[1]);
      var windowSize = 8;
      var _loc2_ = _loc1_.currX - windowSize;
      while(_loc2_ < _loc1_.currX + windowSize)
      {
         var _loc3_ = _loc1_.currY - windowSize;
         while(_loc3_ < _loc1_.currY + windowSize)
         {
            if(_loc1_.cells[_loc2_][_loc3_].clip == undefined)
            {
               _loc1_.cells[_loc2_][_loc3_].clip = new MovieClip();
               _loc1_.attachMovie("Cell","Cell_" + _loc2_ + "_" + _loc3_,_loc1_.cells[_loc2_][_loc3_].depth);
            }
            _loc3_ = _loc3_ + 1;
         }
         _loc2_ = _loc2_ + 1;
      }
      _loc1_.oldX = _loc1_.currX;
      _loc1_.oldY = _loc1_.currY;
      _loc1_.attachMovie("Player","player",9900);
      _loc3_ = 1;
      while(_loc3_ <= _loc1_.numEnemyTypes)
      {
         _loc2_ = 0;
         while(_loc2_ < _loc1_.spawnPoints[_loc3_].length)
         {
            _loc1_.attachMovie("Enemy" + _loc3_,"enemy" + _loc3_ + "_" + _loc2_,6000 + _loc3_ * 50 + _loc2_);
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
      _loc3_ = 0;
      while(_loc3_ < _loc1_.numItemTypes)
      {
         _loc2_ = 0;
         while(_loc2_ < _loc1_.itemPoints[_loc3_].length)
         {
            _loc1_.attachMovie("Item" + _loc3_,"item" + _loc3_ + "_" + _loc2_,7500 + _loc3_ * 50 + _loc2_,{id:_loc2_});
            _loc2_ = _loc2_ + 1;
         }
         _loc3_ = _loc3_ + 1;
      }
   }
   function onEnterFrame()
   {
      var _loc1_ = this;
      if(_root.currLvl == 101)
      {
         if(_loc1_.triggerStatus == 0)
         {
            var r = Math.floor(random(5));
            if(r != _loc1_.triggerMemory)
            {
               _loc1_.triggerStatus = r + 1;
               _loc1_.triggerMemory = r;
            }
         }
      }
      if(_root.currLvl == 102)
      {
         if(_loc1_.triggers[0].pushed && _loc1_.triggers[2].pushed && _loc1_.triggers[3].pushed && _loc1_.triggers[6].pushed)
         {
            _loc1_.triggerPile[0] = true;
         }
         if(_loc1_.triggers[1].pushed && _loc1_.triggers[4].pushed && _loc1_.triggers[5].pushed && _loc1_.triggers[7].pushed)
         {
            _loc1_.triggerPile[1] = true;
         }
         if(_loc1_.triggers[9].pushed && _loc1_.triggers[12].pushed && _loc1_.triggers[13].pushed && _loc1_.triggers[15].pushed)
         {
            _loc1_.triggerPile[2] = true;
         }
         if(_loc1_.triggers[8].pushed && _loc1_.triggers[10].pushed && _loc1_.triggers[11].pushed && _loc1_.triggers[14].pushed)
         {
            _loc1_.triggerPile[3] = true;
         }
         var _loc2_ = 0;
         var _loc3_ = 0;
         while(_loc3_ < 4)
         {
            if(_loc1_.triggerPile[_loc3_])
            {
               _loc2_ = _loc2_ + 1;
            }
            _loc3_ = _loc3_ + 1;
         }
         if(_loc2_ >= 4)
         {
            _root.gotoAndPlay("cinematics");
            §§push(_loc1_.removeMovieClip());
            §§push(_loc1_.removeMovieClip());
         }
      }
      if(_root.currLvl == 103)
      {
         _loc1_.worldTimer = _loc1_.worldTimer + 1;
      }
      if(_loc1_.combatStatus <= 0)
      {
         _root.gotoAndPlay("cinematics");
         §§push(_loc1_.removeMovieClip());
         §§push(_loc1_.removeMovieClip());
      }
      if(_loc1_.camFollow)
      {
         if(_loc1_.player.targetRot == 0)
         {
            _loc1_.targetRot = 0;
         }
         else if(_loc1_.player.targetRot == 90)
         {
            if(_loc1_._parent._rotation >= 180)
            {
               _loc1_.targetRot = 270;
            }
            else
            {
               _loc1_.targetRot = -90;
            }
         }
         else if(_loc1_.player.targetRot == 180)
         {
            if(_loc1_._parent._rotation <= -90)
            {
               _loc1_.targetRot = -180;
            }
            else
            {
               _loc1_.targetRot = 180;
            }
         }
         else if(_loc1_.player.targetRot == -90)
         {
            _loc1_.targetRot = 90;
         }
         _loc1_.targetX = Math.round((- _loc1_.player._x) * 10) / 10;
         _loc1_.targetY = Math.round((- _loc1_.player._y) * 10) / 10;
         var xDist = _loc1_.targetX - _loc1_._x;
         var yDist = _loc1_.targetY - _loc1_._y;
         if(xDist * xDist > 0.5)
         {
            _loc1_._x += xDist / 3;
         }
         else
         {
            _loc1_._x = _loc1_.targetX;
         }
         if(yDist * yDist > 0.5)
         {
            _loc1_._y += yDist / 3;
         }
         else
         {
            _loc1_._y = _loc1_.targetY;
         }
         if((_loc1_.player.targetRot - _loc1_.player._rotation) * (_loc1_.player.targetRot - _loc1_.player._rotation) < 5)
         {
            if((_loc1_.targetRot - _loc1_._parent._rotation) * (_loc1_.targetRot - _loc1_._parent._rotation) > 5)
            {
               _loc1_._parent._rotation += (_loc1_.targetRot - _loc1_._parent._rotation) / 4;
            }
            else
            {
               _loc1_._parent._rotation = _loc1_.targetRot;
               if(_loc1_._parent._rotation == -180)
               {
                  _loc1_._parent._rotation = 180;
               }
               if(_loc1_._parent._rotation == 270)
               {
                  _loc1_._parent._rotation = -90;
               }
            }
         }
         _loc1_.currX = _loc1_.player.xCell;
         _loc1_.currY = _loc1_.player.yCell;
         var xDist = Math.sqrt((_loc1_.currX - _loc1_.oldX) * (_loc1_.currX - _loc1_.oldX));
         var yDist = Math.sqrt((_loc1_.currY - _loc1_.oldY) * (_loc1_.currY - _loc1_.oldY));
         var windowSize = 8;
         if(xDist >= 1 || yDist >= 1)
         {
            _loc3_ = _loc1_.currX - (windowSize + xDist);
            while(_loc3_ < _loc1_.currX + windowSize + xDist)
            {
               _loc2_ = _loc1_.currY - (windowSize + yDist);
               while(_loc2_ < _loc1_.currY + windowSize + yDist)
               {
                  if(_loc3_ > _loc1_.currX - windowSize && _loc3_ < _loc1_.currX + windowSize && _loc2_ > _loc1_.currY - windowSize && _loc2_ < _loc1_.currY + windowSize)
                  {
                     if(_loc1_.cells[_loc3_][_loc2_].clip == undefined)
                     {
                        _loc1_.cells[_loc3_][_loc2_].clip = new MovieClip();
                        if(_loc1_.cells[_loc3_][_loc2_].tile == 0 && _loc1_.cells[_loc3_][_loc2_].spawn != undefined)
                        {
                           _loc1_.attachMovie("Enemy" + _loc1_.cells[_loc3_][_loc2_].spawn,"enemy" + _loc1_.cells[_loc3_][_loc2_].spawn + "_" + _loc1_.cells[_loc3_][_loc2_].spawnId,6000 + _loc1_.cells[_loc3_][_loc2_].spawn * 50 + _loc1_.cells[_loc3_][_loc2_].spawnId);
                        }
                        else if(_loc1_.cells[_loc3_][_loc2_].tile == 0 && _loc1_.cells[_loc3_][_loc2_].item != undefined)
                        {
                           if(_loc1_.cells[_loc3_][_loc2_].itemAlive)
                           {
                              _loc1_.attachMovie("Item" + _loc1_.cells[_loc3_][_loc2_].item,"item" + _loc1_.cells[_loc3_][_loc2_].item + "_" + _loc1_.cells[_loc3_][_loc2_].itemId,7500 + _loc1_.cells[_loc3_][_loc2_].item * 50 + _loc1_.cells[_loc3_][_loc2_].itemId);
                           }
                        }
                        _loc1_.attachMovie("Cell","Cell_" + _loc3_ + "_" + _loc2_,_loc1_.cells[_loc3_][_loc2_].depth);
                     }
                  }
                  else
                  {
                     _loc1_.cells[_loc3_][_loc2_].clip.removeMovieClip();
                     _loc1_.cells[_loc3_][_loc2_].clip = undefined;
                  }
                  _loc2_ = _loc2_ + 1;
               }
               _loc3_ = _loc3_ + 1;
            }
         }
         _loc1_.oldX = _loc1_.currX;
         _loc1_.oldY = _loc1_.currY;
      }
      if(_loc1_.reSpawnCounter > 0)
      {
         _loc1_.reSpawnCounter = _loc1_.reSpawnCounter - 1;
         if(_loc1_.reSpawnCounter == 1)
         {
            _root.health = 100;
            _loc1_.attachMovie("Player","player",5999);
            _loc1_.player.blinking = 60;
         }
      }
   }
   function mapOverlay(mcName, mcScale)
   {
      var _loc1_ = this;
      var _loc2_ = mcScale;
      var _loc3_ = mcName;
      _loc3_;
      _loc2_;
      _loc1_.attachMovie(_loc3_,"overlay",90);
      _loc1_.overlay._x = (- _loc1_.cellsize) / 2;
      _loc1_.overlay._y = (- _loc1_.cellsize) / 2;
      _loc1_.overlay._width *= _loc2_;
      _loc1_.overlay._height *= _loc2_;
   }
   function mapBg(mcName)
   {
      var _loc1_ = mcName;
      var _loc2_ = this;
      _loc1_;
      _loc2_._parent._parent.attachMovie(_loc1_,"bg",1);
      _loc2_._parent._parent.bg._x = 280;
      _loc2_._parent._parent.bg._y = 205;
   }
   function instaFocus()
   {
      var _loc1_ = this;
      _loc1_._x = Math.round((- _loc1_.player._x) * 10) / 10;
      _loc1_._y = Math.round((- _loc1_.player._y) * 10) / 10;
   }
}
